/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 11 "trafgen_parser.y" /* yacc.c:339  */


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <errno.h>
#include <libgen.h>
#include <signal.h>
#include <unistd.h>
#include <net/if_arp.h>
#include <netinet/in.h>
#include <linux/icmp.h>
#include <linux/if_ether.h>
#include <linux/icmpv6.h>

#include "xmalloc.h"
#include "trafgen_parser.tab.h"
#include "trafgen_conf.h"
#include "trafgen_proto.h"
#include "trafgen_l2.h"
#include "trafgen_l3.h"
#include "trafgen_l4.h"
#include "trafgen_l7.h"
#include "built_in.h"
#include "die.h"
#include "str.h"
#include "csum.h"
#include "cpp.h"

#ifndef ETH_P_8021AD
#define ETH_P_8021AD	0x88A8
#endif

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYLTYPE_IS_TRIVIAL	1

extern FILE *yyin;
extern int yylex(void);
extern void yy_scan_string(char *);
extern void yylex_destroy();
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

extern struct packet *packets;
extern size_t plen;

#define packet_last		(plen - 1)

#define payload_last		(packets[packet_last].len - 1)

extern struct packet_dyn *packet_dyn;
extern size_t dlen;

#define packetd_last		(dlen - 1)

#define packetdc_last		(packet_dyn[packetd_last].clen - 1)
#define packetdr_last		(packet_dyn[packetd_last].rlen - 1)
#define packetds_last		(packet_dyn[packetd_last].slen - 1)

static int our_cpu, min_cpu = -1, max_cpu = -1;

enum field_expr_type_t {
	FIELD_EXPR_UNKNOWN	= 0,
	FIELD_EXPR_NUMB		= 1 << 0,
	FIELD_EXPR_MAC		= 1 << 1,
	FIELD_EXPR_IP4_ADDR	= 1 << 2,
	FIELD_EXPR_IP6_ADDR	= 1 << 3,
	FIELD_EXPR_INC		= 1 << 4,
	FIELD_EXPR_RND		= 1 << 5,
	FIELD_EXPR_OFFSET	= 1 << 6,
	FIELD_EXPR_STRING	= 1 << 7,
	FIELD_EXPR_FQDN		= 1 << 8,
};

struct proto_field_expr {
	enum field_expr_type_t type;
	struct proto_field *field;

	union {
		struct in_addr ip4_addr;
		struct in6_addr ip6_addr;
		long long int number;
		uint8_t mac[256];
		char *str;
		struct proto_field_func func;
	} val;
};

static struct proto_field_expr field_expr;
static struct proto_hdr *hdr;

static inline int test_ignore(void)
{
	if (min_cpu < 0 && max_cpu < 0)
		return 0;
	else if (max_cpu >= our_cpu && min_cpu <= our_cpu)
		return 0;
	else
		return 1;
}

static inline void __init_new_packet_slot(struct packet *slot)
{
	memset(slot, 0, sizeof(*slot));
}

static inline void __init_new_counter_slot(struct packet_dyn *slot)
{
	slot->cnt = NULL;
	slot->clen = 0;
}

static inline void __init_new_randomizer_slot(struct packet_dyn *slot)
{
	slot->rnd = NULL;
	slot->rlen = 0;
}

static inline void __init_new_csum_slot(struct packet_dyn *slot)
{
	slot->csum = NULL;
	slot->slen = 0;
}

static inline void __init_new_fields_slot(struct packet_dyn *slot)
{
	slot->fields = NULL;
	slot->flen = 0;
}

static inline void __setup_new_counter(struct counter *c, uint8_t start,
				       uint8_t stop, uint8_t stepping,
				       int type)
{
	c->min = start;
	c->max = stop;
	c->inc = (type == TYPE_INC) ? stepping : -stepping;
	c->val = (type == TYPE_INC) ? start : stop;
	c->off = payload_last;
	c->type = type;
}

static inline void __setup_new_randomizer(struct randomizer *r)
{
	r->off = payload_last;
}

static inline void __setup_new_csum16(struct csum16 *s, off_t from, off_t to,
				      enum csum which)
{
	s->off = payload_last - 1;
	s->from = from;
	s->to = to;
	s->which = which;
}

struct packet *realloc_packet(void)
{
	uint32_t i;

	if (test_ignore())
		return NULL;

	plen++;
	packets = xrealloc(packets, plen * sizeof(*packets));

	__init_new_packet_slot(&packets[packet_last]);

	dlen++;
	packet_dyn = xrealloc(packet_dyn, dlen * sizeof(*packet_dyn));

	__init_new_counter_slot(&packet_dyn[packetd_last]);
	__init_new_randomizer_slot(&packet_dyn[packetd_last]);
	__init_new_csum_slot(&packet_dyn[packetd_last]);
	__init_new_fields_slot(&packet_dyn[packetd_last]);

	for (i = 0; i < plen; i++)
		packets[i].id = i;

	return &packets[packet_last];
}

struct packet *current_packet(void)
{
	return &packets[packet_last];
}

uint32_t current_packet_id(void)
{
	return packet_last;
}

struct packet *packet_get(uint32_t id)
{
	return &packets[id];
}

static void set_byte(uint8_t val)
{
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	pkt->payload[payload_last] = val;
}

static void set_multi_byte(uint8_t *s, size_t len)
{
	size_t i;

	for (i = 0; i < len; ++i)
		set_byte(s[i]);
}

void set_fill(uint8_t val, size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = val;
}

static void __set_csum16_dynamic(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	pkt->len += 2;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->slen++;
	pktd->csum = xrealloc(pktd->csum, pktd->slen * sizeof(struct csum16));

	__setup_new_csum16(&pktd->csum[packetds_last], from, to, which);
}

static void __set_csum16_static(size_t from, size_t to, enum csum which __maybe_unused)
{
	struct packet *pkt = &packets[packet_last];
	uint16_t sum;
	uint8_t *psum;

	sum = htons(calc_csum(pkt->payload + from, to - from));
	psum = (uint8_t *) &sum;

	set_byte(psum[0]);
	set_byte(psum[1]);
}

static inline bool is_dynamic_csum(enum csum which)
{
	switch (which) {
	case CSUM_UDP:
	case CSUM_TCP:
	case CSUM_UDP6:
	case CSUM_TCP6:
		return true;
	default:
		return false;
	}
}

static void set_csum16(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	if (to < from) {
		size_t tmp = to;

		to = from;
		from = tmp;
	}

	bug_on(!(from < to));

	if (packet_dyn_has_elems(pktd) || to >= pkt->len || is_dynamic_csum(which))
		__set_csum16_dynamic(from, to, which);
	else
		__set_csum16_static(from, to, which);
}

static void set_rnd(size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = (uint8_t) rand();
}

static void set_sequential_inc(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		off_t off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start += stepping;
	}
}

static void set_sequential_dec(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		int off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start -= stepping;
	}
}

static void set_dynamic_rnd(void)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->rlen++;
	pktd->rnd = xrealloc(pktd->rnd, pktd->rlen * sizeof(struct randomizer));

	__setup_new_randomizer(&pktd->rnd[packetdr_last]);
}

static void set_dynamic_incdec(uint8_t start, uint8_t stop, uint8_t stepping,
			       int type)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->clen++;
	pktd->cnt = xrealloc(pktd->cnt, pktd->clen * sizeof(struct counter));

	__setup_new_counter(&pktd->cnt[packetdc_last], start, stop, stepping, type);
}

static void proto_add(enum proto_id pid)
{
	hdr = proto_header_push(pid);
}

static void proto_field_set(uint32_t fid)
{
	memset(&field_expr, 0, sizeof(field_expr));
	field_expr.field = proto_hdr_field_by_id(hdr, fid);
}

static void proto_field_func_setup(struct proto_field *field, struct proto_field_func *func)
{
	struct proto_field *field_copy;
	struct packet_dyn *pkt_dyn;

	field_copy = xmalloc(sizeof(*field));
	memcpy(field_copy, field, sizeof(*field));

	field_copy->pkt_offset += func->offset;
	if (func->len)
		field_copy->len = func->len;

	proto_field_func_add(field_copy, func);

	pkt_dyn = &packet_dyn[packetd_last];
	pkt_dyn->flen++;
	pkt_dyn->fields = xrealloc(pkt_dyn->fields, pkt_dyn->flen *
				   sizeof(struct proto_field *));

	pkt_dyn->fields[pkt_dyn->flen - 1] = field_copy;
}

static void proto_field_expr_eval(void)
{
	struct proto_field *field = field_expr.field;

	if ((field_expr.type & FIELD_EXPR_OFFSET) &&
			!((field_expr.type & FIELD_EXPR_INC) ||
				(field_expr.type & FIELD_EXPR_RND))) {

		panic("Field offset expression is valid only with function expression\n");
	}

	if (field_expr.type & FIELD_EXPR_NUMB) {
		if (field->len == 1)
			proto_field_set_u8(field, field_expr.val.number);
		else if (field->len == 2)
			proto_field_set_be16(field, field_expr.val.number);
		else if (field->len == 4)
			proto_field_set_be32(field, field_expr.val.number);
		else
			panic("Invalid value length %zu, can be 1,2 or 4\n", field->len);
	} else if (field_expr.type & FIELD_EXPR_MAC) {
		proto_field_set_bytes(field, field_expr.val.mac, 6);
	} else if (field_expr.type & FIELD_EXPR_FQDN) {
		char *fqdn = str2fqdn(field_expr.val.str);
		proto_field_set_bytes(field, (uint8_t *) fqdn, strlen(fqdn) + 1);
		xfree(field_expr.val.str);
		xfree(fqdn);
	} else if (field_expr.type & FIELD_EXPR_STRING) {
		proto_field_set_string(field, field_expr.val.str);
		xfree(field_expr.val.str);
	} else if (field_expr.type & FIELD_EXPR_IP4_ADDR) {
		proto_field_set_u32(field, field_expr.val.ip4_addr.s_addr);
	} else if (field_expr.type & FIELD_EXPR_IP6_ADDR) {
		proto_field_set_bytes(field, (uint8_t *)&field_expr.val.ip6_addr.s6_addr, 16);
	} else if ((field_expr.type & FIELD_EXPR_INC) ||
			(field_expr.type & FIELD_EXPR_RND)) {

		if (field_expr.val.func.min
			&& field_expr.val.func.min >= field_expr.val.func.max)
			panic("dinc(): min(%u) can't be >= max(%u)\n",
				field_expr.val.func.min, field_expr.val.func.max);

		proto_field_func_setup(field, &field_expr.val.func);
	} else if ((field_expr.type & FIELD_EXPR_OFFSET) &&
			!((field_expr.type & FIELD_EXPR_INC) ||
				(field_expr.type & FIELD_EXPR_RND))) {

		panic("Field expression is valid only for function value expression\n");
	} else {
		bug();
	}

	memset(&field_expr, 0, sizeof(field_expr));
}

static void field_index_validate(struct proto_field *field, uint16_t index, size_t len)
{
	if (field_expr.field->len <= index) {
		yyerror("Invalid [index] parameter");
		panic("Index (%u) is bigger than field's length (%zu)\n",
		       index, field->len);
	}
	if (len != 1 && len != 2 && len != 4) {
		yyerror("Invalid [index:len] parameter");
		panic("Invalid index length - 1,2 or 4 is only allowed\n");
	}
}

static void proto_push_sub_hdr(uint32_t id)
{
	hdr = proto_hdr_push_sub_header(hdr, id);
}

static void proto_pop_sub_hdr(void)
{
	if (hdr->ops->header_finish)
		hdr->ops->header_finish(hdr);

	hdr = hdr->parent;
}


#line 564 "trafgen/trafgen_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "trafgen_parser.tab.h".  */
#ifndef YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
# define YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    K_COMMENT = 258,
    K_FILL = 259,
    K_RND = 260,
    K_SEQINC = 261,
    K_SEQDEC = 262,
    K_DRND = 263,
    K_DINC = 264,
    K_DDEC = 265,
    K_WHITE = 266,
    K_CPU = 267,
    K_CSUMIP = 268,
    K_CSUMUDP = 269,
    K_CSUMTCP = 270,
    K_CSUMUDP6 = 271,
    K_CSUMTCP6 = 272,
    K_CONST8 = 273,
    K_CONST16 = 274,
    K_CONST32 = 275,
    K_CONST64 = 276,
    K_DADDR = 277,
    K_SADDR = 278,
    K_ETYPE = 279,
    K_TYPE = 280,
    K_TIME = 281,
    K_PRIO = 282,
    K_OPER = 283,
    K_SHA = 284,
    K_SPA = 285,
    K_THA = 286,
    K_TPA = 287,
    K_REQUEST = 288,
    K_REPLY = 289,
    K_PTYPE = 290,
    K_HTYPE = 291,
    K_PROT = 292,
    K_TTL = 293,
    K_DSCP = 294,
    K_ECN = 295,
    K_TOS = 296,
    K_LEN = 297,
    K_ID = 298,
    K_FLAGS = 299,
    K_FRAG = 300,
    K_IHL = 301,
    K_VER = 302,
    K_CSUM = 303,
    K_DF = 304,
    K_MF = 305,
    K_FLOW = 306,
    K_NEXT_HDR = 307,
    K_HOP_LIMIT = 308,
    K_CODE = 309,
    K_ECHO_REQUEST = 310,
    K_ECHO_REPLY = 311,
    K_SPORT = 312,
    K_DPORT = 313,
    K_SEQ = 314,
    K_ACK_SEQ = 315,
    K_DOFF = 316,
    K_CWR = 317,
    K_ECE = 318,
    K_URG = 319,
    K_ACK = 320,
    K_PSH = 321,
    K_RST = 322,
    K_SYN = 323,
    K_FIN = 324,
    K_WINDOW = 325,
    K_URG_PTR = 326,
    K_TPID = 327,
    K_TCI = 328,
    K_PCP = 329,
    K_DEI = 330,
    K_1Q = 331,
    K_1AD = 332,
    K_LABEL = 333,
    K_TC = 334,
    K_LAST = 335,
    K_EXP = 336,
    K_ADDR = 337,
    K_MTU = 338,
    K_QR = 339,
    K_AANSWER = 340,
    K_TRUNC = 341,
    K_RAVAIL = 342,
    K_RDESIRED = 343,
    K_ZERO = 344,
    K_RCODE = 345,
    K_QDCOUNT = 346,
    K_ANCOUNT = 347,
    K_NSCOUNT = 348,
    K_ARCOUNT = 349,
    K_QUERY = 350,
    K_ANSWER = 351,
    K_AUTH = 352,
    K_ADD = 353,
    K_NAME = 354,
    K_CLASS = 355,
    K_DATA = 356,
    K_NS = 357,
    K_CNAME = 358,
    K_PTR = 359,
    K_ETH = 360,
    K_PAUSE = 361,
    K_PFC = 362,
    K_VLAN = 363,
    K_MPLS = 364,
    K_ARP = 365,
    K_IP4 = 366,
    K_IP6 = 367,
    K_ICMP4 = 368,
    K_ICMP6 = 369,
    K_UDP = 370,
    K_TCP = 371,
    K_DNS = 372,
    number = 373,
    string = 374,
    mac = 375,
    ip4_addr = 376,
    ip6_addr = 377
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 509 "trafgen_parser.y" /* yacc.c:355  */

	struct in_addr ip4_addr;
	struct in6_addr ip6_addr;
	long long int number;
	uint8_t mac[6];
	char *str;

#line 735 "trafgen/trafgen_parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 752 "trafgen/trafgen_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   786

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  142
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  109
/* YYNRULES -- Number of rules.  */
#define YYNRULES  340
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  698

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   377

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   130,   131,     2,
     121,   122,   128,   127,   118,   126,     2,   129,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   125,     2,
     133,   141,   134,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   123,     2,   124,   135,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,   132,   120,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   136,   137,   138,   139,   140
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   562,   562,   563,   564,   565,   569,   573,   574,   578,
     579,   583,   584,   585,   589,   590,   593,   600,   615,   625,
     626,   630,   631,   635,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   655,   657,   659,
     661,   663,   665,   667,   669,   671,   673,   675,   677,   679,
     684,   689,   691,   696,   701,   709,   714,   716,   718,   720,
     722,   727,   729,   734,   736,   741,   743,   752,   754,   759,
     761,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   782,   787,   795,   797,   799,   802,
     804,   806,   809,   813,   820,   827,   829,   837,   841,   845,
     846,   847,   851,   852,   853,   857,   858,   859,   862,   864,
     869,   873,   877,   878,   879,   883,   884,   888,   890,   895,
     899,   903,   904,   905,   909,   910,   911,   917,   926,   928,
     933,   937,   941,   942,   943,   947,   948,   952,   953,   954,
     955,   956,   960,   962,   964,   966,   971,   975,   979,   980,
     981,   985,   986,   990,   991,   992,   993,   997,   999,  1004,
    1008,  1009,  1010,  1014,  1016,  1018,  1020,  1022,  1024,  1029,
    1031,  1033,  1036,  1039,  1041,  1043,  1045,  1050,  1054,  1058,
    1059,  1060,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1081,  1083,  1085,  1086,
    1090,  1094,  1098,  1099,  1100,  1104,  1105,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1120,  1122,  1127,  1131,  1135,
    1136,  1137,  1141,  1142,  1143,  1144,  1145,  1146,  1150,  1152,
    1154,  1157,  1163,  1167,  1171,  1172,  1173,  1177,  1178,  1182,
    1184,  1186,  1189,  1192,  1194,  1196,  1198,  1202,  1206,  1210,
    1211,  1212,  1216,  1217,  1218,  1219,  1223,  1225,  1230,  1234,
    1238,  1239,  1240,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,  1255,  1257,  1259,  1260,  1261,  1262,  1263,  1264,  1265,
    1266,  1270,  1274,  1278,  1279,  1280,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,  1300,
    1304,  1308,  1309,  1313,  1315,  1317,  1321,  1328,  1329,  1330,
    1334,  1338,  1339,  1340,  1344,  1348,  1351,  1357,  1368,  1370,
    1372,  1374,  1379,  1380,  1381,  1382,  1383,  1387,  1389,  1391,
    1395,  1399,  1404,  1405,  1406,  1410,  1414,  1416,  1418,  1419,
    1423
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_COMMENT", "K_FILL", "K_RND",
  "K_SEQINC", "K_SEQDEC", "K_DRND", "K_DINC", "K_DDEC", "K_WHITE", "K_CPU",
  "K_CSUMIP", "K_CSUMUDP", "K_CSUMTCP", "K_CSUMUDP6", "K_CSUMTCP6",
  "K_CONST8", "K_CONST16", "K_CONST32", "K_CONST64", "K_DADDR", "K_SADDR",
  "K_ETYPE", "K_TYPE", "K_TIME", "K_PRIO", "K_OPER", "K_SHA", "K_SPA",
  "K_THA", "K_TPA", "K_REQUEST", "K_REPLY", "K_PTYPE", "K_HTYPE", "K_PROT",
  "K_TTL", "K_DSCP", "K_ECN", "K_TOS", "K_LEN", "K_ID", "K_FLAGS",
  "K_FRAG", "K_IHL", "K_VER", "K_CSUM", "K_DF", "K_MF", "K_FLOW",
  "K_NEXT_HDR", "K_HOP_LIMIT", "K_CODE", "K_ECHO_REQUEST", "K_ECHO_REPLY",
  "K_SPORT", "K_DPORT", "K_SEQ", "K_ACK_SEQ", "K_DOFF", "K_CWR", "K_ECE",
  "K_URG", "K_ACK", "K_PSH", "K_RST", "K_SYN", "K_FIN", "K_WINDOW",
  "K_URG_PTR", "K_TPID", "K_TCI", "K_PCP", "K_DEI", "K_1Q", "K_1AD",
  "K_LABEL", "K_TC", "K_LAST", "K_EXP", "K_ADDR", "K_MTU", "K_QR",
  "K_AANSWER", "K_TRUNC", "K_RAVAIL", "K_RDESIRED", "K_ZERO", "K_RCODE",
  "K_QDCOUNT", "K_ANCOUNT", "K_NSCOUNT", "K_ARCOUNT", "K_QUERY",
  "K_ANSWER", "K_AUTH", "K_ADD", "K_NAME", "K_CLASS", "K_DATA", "K_NS",
  "K_CNAME", "K_PTR", "K_ETH", "K_PAUSE", "K_PFC", "K_VLAN", "K_MPLS",
  "K_ARP", "K_IP4", "K_IP6", "K_ICMP4", "K_ICMP6", "K_UDP", "K_TCP",
  "K_DNS", "','", "'{'", "'}'", "'('", "')'", "'['", "']'", "':'", "'-'",
  "'+'", "'*'", "'/'", "'%'", "'&'", "'|'", "'<'", "'>'", "'^'", "number",
  "string", "mac", "ip4_addr", "ip6_addr", "'='", "$accept", "packets",
  "inline_comment", "cpu_delim", "delimiter_nowhite", "noenforce_white",
  "skip_white", "packet", "payload", "delimiter", "elem_delimiter", "elem",
  "expression", "fill", "const", "rnd", "csum", "seqinc", "seqdec", "drnd",
  "dinc", "ddec", "proto", "field_expr", "field_value_expr", "eth_proto",
  "eth", "eth_param_list", "eth_type", "eth_field", "eth_expr",
  "pause_proto", "pause", "pause_param_list", "pause_field", "pause_expr",
  "pfc_proto", "pfc", "pfc_param_list", "pfc_field", "pfc_expr",
  "vlan_proto", "vlan", "vlan_param_list", "vlan_type", "vlan_field",
  "vlan_expr", "mpls_proto", "mpls", "mpls_param_list", "mpls_tc",
  "mpls_field", "mpls_expr", "arp_proto", "arp_param_list", "arp_field",
  "arp_expr", "arp", "ip4_proto", "ip4_param_list", "ip4_field",
  "ip4_expr", "ip4", "ip6_proto", "ip6_param_list", "ip6_hop_limit",
  "ip6_field", "ip6_expr", "ip6", "icmp4_proto", "icmp4_param_list",
  "icmp4_field", "icmp4_expr", "icmp4", "icmpv6_proto", "icmp6_param_list",
  "icmp6_field", "icmp6_expr", "icmp6", "udp_proto", "udp_param_list",
  "udp_field", "udp_expr", "udp", "tcp_proto", "tcp_param_list",
  "tcp_field", "tcp_expr", "tcp", "dns_proto", "dns_param_list",
  "dns_field", "dns_query", "dns_query_name", "dns_query_field",
  "dns_query_expr", "dns_query_param_list", "dns_query_hdr", "dns_rrecord",
  "dns_rrecord_name", "dns_rrecord_data_addr", "dns_rrecord_data_fqdn",
  "dns_rrecord_data_expr", "dns_rrecord_field", "dns_rrecord_expr",
  "dns_rrecord_param_list", "dns_rrecord_hdr", "dns_expr", "dns", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,    44,   123,
     125,    40,    41,    91,    93,    58,    45,    43,    42,    47,
      37,    38,   124,    60,    62,    94,   373,   374,   375,   376,
     377,    61
};
# endif

#define YYPACT_NINF -485

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-485)))

#define YYTABLE_NINF -14

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -485,    16,  -485,  -485,  -485,   -98,    -4,  -485,  -485,  -100,
    -485,    30,  -485,   649,   -34,  -485,   -74,   -72,   -65,   -59,
     -53,   -27,   -24,   -21,   -16,   -11,    -9,     2,     5,    58,
      59,    60,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,     7,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,    61,  -485,    63,  -485,    65,  -485,    66,  -485,    67,
    -485,    68,  -485,    70,  -485,    71,  -485,    74,  -485,    79,
    -485,    81,  -485,    92,  -485,    94,   -60,  -485,  -485,   -49,
     -20,    24,    85,    90,   -92,    91,    97,    98,    99,   101,
     102,   104,   -43,   -43,   -43,   -43,    38,   121,   123,   649,
    -485,   146,     0,    55,   135,    23,   323,   428,   152,   142,
      -3,   172,   529,   351,    -4,    21,    13,    95,    13,    13,
    -485,   122,    13,    13,    13,    13,    13,    13,    13,   -43,
     -43,  -485,   240,   385,   549,   595,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,   125,  -485,     6,    13,  -485,  -485,   126,
       6,    13,   124,   128,  -485,   129,     6,    13,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,   130,  -485,     6,    13,
    -485,  -485,  -485,  -485,  -485,   131,  -485,     6,    13,     6,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,   133,     6,
      13,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,   134,     6,    13,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,   136,
    -485,     6,    13,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,   137,     6,    13,     6,  -485,  -485,  -485,  -485,   139,
       6,    13,  -485,  -485,  -485,  -485,   140,     6,    13,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,   143,     6,    13,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,   144,     6,   148,  -485,   149,
    -485,    13,   154,   161,  -485,  -485,   138,  -485,   151,   159,
    -485,   160,   162,   163,   165,   166,   168,   169,   609,  -485,
    -485,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   173,   145,
     -43,  -485,  -485,  -485,  -485,  -485,   256,   171,   256,   146,
    -485,   174,   256,     0,   177,   180,  -485,   179,   256,    55,
    -485,   182,   256,   135,  -485,   183,   256,    23,   185,   256,
    -485,   186,   256,   323,  -485,   188,   256,   428,  -485,   189,
     256,   152,  -485,   191,   256,   142,   193,   256,  -485,   194,
     256,    -3,  -485,   196,   256,   172,  -485,   197,   256,   529,
    -485,   199,   256,   -10,   181,   351,    -4,    -4,   187,    -5,
      14,    20,    22,   219,   221,   222,   224,   254,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,   -43,   -43,  -485,   241,
     256,   245,  -485,   256,   247,  -485,   259,   260,   256,   251,
    -485,   256,   255,  -485,   256,   257,  -485,   256,   261,   256,
     263,  -485,   256,   265,  -485,   256,   267,  -485,   256,   268,
    -485,    18,   269,   256,   271,  -485,   256,   273,  -485,   256,
     275,  -485,   256,   277,  -485,  -485,  -485,     6,     6,    13,
     278,  -485,  -485,  -485,   150,  -485,  -485,  -485,   200,   299,
     301,     6,  -485,     6,    13,   302,  -485,   649,   306,  -485,
    -485,   294,  -485,   296,  -485,   298,  -485,   316,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,   256,    12,   256,    12,   256,
    -485,  -485,    12,   256,    12,   256,    12,   256,    26,   256,
      12,   256,    12,   256,    12,   256,    12,   256,  -485,  -485,
      12,   256,    12,   256,    12,   256,    12,   256,    12,   256,
     312,   256,   313,   256,   -10,  -485,   256,   256,   256,   256,
     314,   256,   315,   256,   181,  -485,     7,    -4,   335,   336,
     337,   338,   -86,   340,   341,  -485,  -485,  -485,  -485,  -485,
    -485,    12,  -485,    12,  -485,    12,  -485,    12,  -485,    12,
    -485,  -485,  -485,    12,  -485,    12,  -485,    12,  -485,    12,
    -485,    12,  -485,    12,  -485,    12,  -485,    12,  -485,    12,
    -485,    12,   256,   322,   256,   339,  -485,   -19,   170,   170,
     170,   256,   342,   256,   344,  -485,   190,   649,  -485,  -485,
    -485,  -485,  -485,   256,   -56,   -37,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,    12,   256,    12,   256,  -485,  -485,   256,  -485,   256,
     256,   256,    12,   256,    12,   256,  -485,     7,   328,  -485,
      13,  -485,    37,  -485,    12,  -485,    12,   357,   359,   364,
     365,  -485,    12,  -485,    12,   198,   256,   352,  -485,   353,
    -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,  -485,   366,
     370,    39,  -485,  -485,  -485,   358,   373,  -485
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     6,     5,     0,    11,     4,     3,     0,
      12,     9,    13,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    98,   111,   120,   131,   147,   177,   200,   217,
     232,   247,   258,   281,   340,    24,    25,    36,    11,    19,
      26,    34,    27,    33,    29,    30,    28,    31,    32,    35,
      71,     0,    72,     0,    73,     0,    74,     0,    75,     0,
      76,     0,    77,     0,    78,     0,    79,     0,    80,     0,
      81,     0,    82,     0,    83,     0,     0,     7,     8,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,    21,     0,     0,
      20,    99,   112,   121,   132,   148,   160,   179,   202,   219,
     234,   249,   260,   283,    11,     0,     0,     0,     0,     0,
      65,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     0,    16,    23,   105,   106,
     102,   103,   104,     0,   107,    14,   100,   116,   115,     0,
      14,   113,     0,   125,   124,     0,    14,   122,   136,   141,
     135,   138,   139,   140,   144,   145,     0,   137,    14,   133,
     156,   153,   151,   155,   152,     0,   154,    14,   149,    14,
     165,   167,   166,   168,   175,   176,   164,   163,     0,    14,
     161,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   183,   182,   195,   198,   199,     0,    14,   180,
     214,   213,   206,   210,   207,   209,   211,   205,   208,     0,
     212,    14,   203,   222,   224,   223,   230,   231,   225,   227,
     226,     0,    14,   220,    14,   238,   237,   244,   246,     0,
      14,   235,   254,   255,   252,   253,     0,    14,   250,   269,
     263,   264,   265,   266,   267,   273,   274,   275,   276,   277,
     278,   279,   280,   268,   270,     0,    14,   261,   288,   286,
     287,   289,   290,   292,   291,   293,   294,   295,   296,   297,
     298,   299,   311,   312,   313,     0,    14,     0,   338,     0,
     339,   284,     0,     0,    22,    21,     0,    55,     0,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,    48,
      51,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    52,    53,    54,    97,    15,    14,     0,    14,    99,
     110,     0,    14,   112,     0,     0,   119,     0,    14,   121,
     130,     0,    14,   132,   146,     0,    14,   148,     0,    14,
     159,     0,    14,   160,   178,     0,    14,   179,   201,     0,
      14,   202,   218,     0,    14,   219,     0,    14,   233,     0,
      14,   234,   248,     0,    14,   249,   259,     0,    14,   260,
     282,     0,    14,   307,   332,   283,    11,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,    39,
      38,    40,    41,    42,    43,    44,     0,     0,    45,     0,
      14,     0,   101,    14,     0,   114,     0,     0,    14,     0,
     123,    14,     0,   134,    14,     0,   150,    14,     0,    14,
       0,   162,    14,     0,   181,    14,     0,   204,    14,     0,
     221,    14,     0,    14,     0,   236,    14,     0,   251,    14,
       0,   262,    14,     0,   301,   300,   302,    14,    14,   308,
       0,   322,   324,   325,     0,   314,   323,   326,     0,     0,
       0,    14,   331,    14,   333,     0,   285,     0,     0,    50,
      61,     0,    63,     0,    67,     0,    69,     0,    56,    58,
      57,    60,    59,    46,    47,    14,     0,    14,     0,    14,
     127,   126,     0,    14,     0,    14,     0,    14,     0,    14,
       0,    14,     0,    14,     0,    14,     0,    14,   243,   245,
       0,    14,     0,    14,     0,    14,     0,    14,     0,    14,
       0,    14,     0,    14,   307,   310,    14,    14,    14,    14,
       0,    14,     0,    14,   332,   335,    11,    11,     0,     0,
       0,     0,     0,     0,     0,    86,    88,    87,    89,    90,
     109,     0,   118,     0,   129,     0,   143,     0,   158,     0,
     173,   174,   172,     0,   170,     0,   197,     0,   216,     0,
     229,     0,   242,     0,   240,     0,   257,     0,   272,     0,
     337,     0,    14,     0,    14,     0,   309,     0,     0,     0,
       0,    14,     0,    14,     0,   334,     0,     0,    62,    64,
      68,    70,    84,    14,     0,     0,   108,   117,   128,   142,
     157,   171,   169,   196,   215,   228,   241,   239,   256,   271,
     336,     0,    14,     0,    14,   315,   316,    14,   317,    14,
      14,    14,     0,    14,     0,    14,    18,    11,     0,    95,
       0,    91,     0,   306,     0,   304,     0,     0,     0,     0,
       0,   330,     0,   328,     0,     0,    14,     0,    92,     0,
     305,   303,   318,   319,   320,   321,   329,   327,    17,     0,
       0,     0,    85,    96,    93,     0,     0,    94
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -485,  -485,   495,  -485,    -6,   -47,  -120,  -485,  -484,  -124,
    -485,   388,   -33,  -485,  -485,  -485,  -485,  -485,  -485,  -485,
    -485,  -485,  -485,  -103,    46,  -485,  -485,   167,  -485,  -485,
    -485,  -485,  -485,   155,  -485,  -485,  -485,  -485,   153,  -485,
    -485,  -485,  -485,   147,  -485,  -485,  -485,  -485,  -485,   164,
    -485,  -485,  -485,  -485,   141,  -485,  -485,  -485,  -485,   132,
    -485,  -485,  -485,  -485,   157,  -485,  -485,  -485,  -485,  -485,
     178,  -485,  -485,  -485,  -485,   120,  -485,  -485,  -485,  -485,
     156,  -485,  -485,  -485,  -485,   116,  -485,  -485,  -485,  -485,
     113,  -485,  -485,  -485,  -485,  -485,   -18,  -485,  -485,  -485,
    -485,  -464,  -485,  -485,  -485,   -31,  -485,  -485,  -485
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    47,    89,   305,    13,   337,     8,    48,   109,
     110,    49,   142,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,   338,   570,    60,    61,   153,   154,   155,
     156,    62,    63,   159,   160,   161,    64,    65,   165,   166,
     167,    66,    67,   176,   177,   178,   179,    68,    69,   185,
     186,   187,   188,    70,   198,   199,   200,    71,    72,   217,
     218,   219,    73,    74,   229,   230,   231,   232,    75,    76,
     241,   242,   243,    77,    78,   249,   250,   251,    79,    80,
     256,   257,   258,    81,    82,   275,   276,   277,    83,    84,
     295,   296,   297,   467,   468,   469,   470,   298,   299,   481,
     647,   649,   482,   483,   484,   485,   300,   301,    85
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      12,   108,   306,   556,   308,   309,   304,    10,   311,   312,
     313,   314,   315,   316,   317,   464,     2,   335,   106,     3,
     563,   564,   244,     9,   304,   304,   157,     4,     5,   335,
     130,   304,   339,   304,   563,   564,    14,   343,   622,   623,
     341,    15,   107,   349,   131,   245,   347,    90,   304,    91,
     304,   246,   247,   248,   158,   353,    92,   342,   351,   580,
     581,   180,    93,   348,   357,   124,   659,   355,    94,   358,
     143,   144,   145,   528,   529,   352,   363,   302,   139,   361,
     660,   162,   163,   140,   356,   661,   359,   125,    86,   465,
     466,    87,    88,   141,    95,   367,   362,    96,   365,   662,
      97,   181,   182,   183,   184,    98,   318,   319,   371,   164,
      99,   369,   100,    11,    11,   366,   126,   490,    12,   375,
     645,   646,   373,   101,   376,    11,   102,   381,   370,   336,
     379,    11,    11,   657,   385,     6,   492,   383,    11,   374,
      11,   377,   494,   303,   496,   650,   651,   380,   565,   566,
     567,   568,   569,   389,   384,    11,   387,    11,   -12,   678,
     127,   694,   565,   566,   567,   568,   569,   233,   148,   149,
     150,   151,   168,   388,   220,   221,   391,   395,   169,   103,
     104,   105,   111,   152,   112,   234,   113,   114,   115,   116,
     222,   117,   118,   392,   223,   119,   235,   236,   237,   224,
     120,   238,   121,   225,   226,   227,   471,   170,   171,   172,
     173,   174,   175,   122,   252,   123,   419,   307,   421,   472,
     253,   128,   424,   473,   239,   240,   129,   132,   429,   254,
     255,   228,   432,   133,   134,   135,   435,   136,   137,   438,
     138,   -13,   440,   146,   310,   344,   443,   334,   340,   345,
     446,   346,   350,   354,   449,   360,   364,   452,   368,   372,
     454,   378,   382,   474,   457,   386,   390,   335,   460,   393,
     394,   546,   463,   396,   398,   491,   493,   495,   497,   417,
     475,   476,   477,   478,   479,   480,   397,   399,   409,   410,
     411,   412,   413,   414,   415,   400,   401,   418,   402,   403,
     506,   404,   405,   508,   406,   407,   416,   648,   512,   489,
     656,   514,   420,   426,   516,   423,   427,   518,   688,   520,
     428,   547,   522,   431,   434,   524,   437,   439,   526,   442,
     445,   530,   448,   532,   451,   453,   534,   456,   459,   536,
     462,   498,   538,   499,   500,   544,   501,   540,   542,   487,
     488,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     554,   550,   320,   552,   541,   543,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   502,   505,   551,   278,
     553,   510,   511,   503,   504,   562,   507,   571,   509,   573,
      12,    12,   513,   575,   279,   577,   515,   579,   517,   583,
     545,   585,   519,   587,   521,   589,   523,   591,   525,   527,
     531,   593,   533,   595,   535,   597,   537,   599,   539,   601,
     548,   603,   549,   605,   555,   557,   607,   608,   609,   610,
     558,   612,   559,   614,   560,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     201,   202,   561,   602,   604,   611,   613,   618,   619,   620,
     621,   624,   625,   642,   676,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   682,
     644,   683,   641,   653,   643,   655,   684,   685,   690,   691,
     692,   652,   693,   654,   696,   697,     7,   147,   425,   444,
     433,   455,   430,   658,   441,   461,   422,   331,   486,   616,
     617,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   436,   664,   615,   666,     0,   606,   667,   447,   668,
     669,   670,     0,   672,     0,   674,   677,     0,   679,     0,
       0,   458,     0,     0,     0,     0,     0,     0,     0,     0,
     107,    12,     0,   450,   572,     0,   689,     0,   574,     0,
     576,     0,   578,     0,   582,     0,   584,   695,   586,     0,
     588,     0,   590,     0,     0,     0,   592,   259,   594,     0,
     596,     0,   598,     0,   600,     0,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     675,     0,     0,     0,     0,     0,     0,   626,     0,   627,
       0,   628,     0,   629,     0,   630,     0,     0,     0,   631,
       0,   632,     0,   633,     0,   634,     0,   635,     0,   636,
       0,   637,     0,   638,     0,   639,     0,   640,     0,     0,
       0,   107,     3,    16,    17,    18,    19,    20,    21,    22,
       0,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   332,     0,     0,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,     0,     0,   663,     0,   665,
       0,     0,     0,     0,     0,     0,     0,     0,   671,     0,
     673,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     680,     0,   681,     0,     0,     0,     0,   333,   686,     0,
     687,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   408,     0,     0,     0,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46
};

static const yytype_int16 yycheck[] =
{
       6,    48,   126,   487,   128,   129,    11,    11,   132,   133,
     134,   135,   136,   137,   138,    25,     0,    11,    11,     3,
       8,     9,    25,   121,    11,    11,    26,    11,    12,    11,
     122,    11,   156,    11,     8,     9,   136,   161,   124,   125,
     160,    11,    48,   167,   136,    48,   166,   121,    11,   121,
      11,    54,    55,    56,    54,   179,   121,   160,   178,    33,
      34,    38,   121,   166,   188,   125,   122,   187,   121,   189,
     103,   104,   105,    55,    56,   178,   200,   124,   121,   199,
     136,    26,    27,   126,   187,   122,   189,   136,   122,    99,
     100,   125,   126,   136,   121,   219,   199,   121,   218,   136,
     121,    78,    79,    80,    81,   121,   139,   140,   232,    54,
     121,   231,   121,   118,   118,   218,   136,   122,   124,   243,
     139,   140,   242,   121,   244,   118,   121,   251,   231,   123,
     250,   118,   118,   617,   258,   119,   122,   257,   118,   242,
     118,   244,   122,   122,   122,   609,   610,   250,   136,   137,
     138,   139,   140,   277,   257,   118,   276,   118,   120,   122,
     136,   122,   136,   137,   138,   139,   140,    25,    22,    23,
      24,    25,    37,   276,    22,    23,   296,   301,    43,   121,
     121,   121,   121,    37,   121,    43,   121,   121,   121,   121,
      38,   121,   121,   296,    42,   121,    54,    55,    56,    47,
     121,    59,   121,    51,    52,    53,    25,    72,    73,    74,
      75,    76,    77,   121,    42,   121,   336,   122,   338,    38,
      48,   136,   342,    42,    82,    83,   136,   136,   348,    57,
      58,    79,   352,   136,   136,   136,   356,   136,   136,   359,
     136,   120,   362,   120,   122,   121,   366,   122,   122,   121,
     370,   122,   122,   122,   374,   122,   122,   377,   122,   122,
     380,   122,   122,    82,   384,   122,   122,    11,   388,   121,
     121,   121,   392,   119,   136,   399,   400,   401,   402,   134,
      99,   100,   101,   102,   103,   104,   125,   136,   321,   322,
     323,   324,   325,   326,   327,   136,   136,   330,   136,   136,
     420,   136,   136,   423,   136,   136,   133,   137,   428,   122,
     120,   431,   141,   136,   434,   141,   136,   437,   120,   439,
     141,   121,   442,   141,   141,   445,   141,   141,   448,   141,
     141,   451,   141,   453,   141,   141,   456,   141,   141,   459,
     141,   122,   462,   122,   122,   469,   122,   467,   468,   396,
     397,    28,    29,    30,    31,    32,    33,    34,    35,    36,
     484,   481,   122,   483,   467,   468,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   122,   136,   481,    28,
     483,   122,   122,   416,   417,   505,   141,   507,   141,   509,
     396,   397,   141,   513,    43,   515,   141,   517,   141,   519,
     122,   521,   141,   523,   141,   525,   141,   527,   141,   141,
     141,   531,   141,   533,   141,   535,   141,   537,   141,   539,
     121,   541,   121,   543,   122,   119,   546,   547,   548,   549,
     136,   551,   136,   553,   136,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      22,    23,   136,   141,   141,   141,   141,   122,   122,   122,
     122,   121,   121,   141,   136,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,   122,
     141,   122,   602,   141,   604,   141,   122,   122,   136,   136,
     124,   611,   122,   613,   136,   122,     1,   109,   343,   367,
     353,   381,   349,   623,   363,   389,   339,   122,   395,   556,
     557,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   357,   642,   554,   644,    -1,   544,   647,   371,   649,
     650,   651,    -1,   653,    -1,   655,   660,    -1,   662,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     556,   557,    -1,   375,   508,    -1,   676,    -1,   512,    -1,
     514,    -1,   516,    -1,   518,    -1,   520,   691,   522,    -1,
     524,    -1,   526,    -1,    -1,    -1,   530,    48,   532,    -1,
     534,    -1,   536,    -1,   538,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     657,    -1,    -1,    -1,    -1,    -1,    -1,   571,    -1,   573,
      -1,   575,    -1,   577,    -1,   579,    -1,    -1,    -1,   583,
      -1,   585,    -1,   587,    -1,   589,    -1,   591,    -1,   593,
      -1,   595,    -1,   597,    -1,   599,    -1,   601,    -1,    -1,
      -1,   657,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    13,    14,    15,    16,    17,    18,    19,    20,
      21,   122,    -1,    -1,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,   641,    -1,   643,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   652,    -1,
     654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     664,    -1,   666,    -1,    -1,    -1,    -1,   122,   672,    -1,
     674,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   122,    -1,    -1,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   136,   137
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   143,     0,     3,    11,    12,   119,   144,   149,   121,
      11,   118,   146,   147,   136,    11,     4,     5,     6,     7,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      20,    21,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   136,   137,   144,   150,   153,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     167,   168,   173,   174,   178,   179,   183,   184,   189,   190,
     195,   199,   200,   204,   205,   210,   211,   215,   216,   220,
     221,   225,   226,   230,   231,   250,   122,   125,   126,   145,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,    11,   146,   147,   151,
     152,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   125,   136,   136,   136,   136,   136,
     122,   136,   136,   136,   136,   136,   136,   136,   136,   121,
     126,   136,   154,   154,   154,   154,   120,   153,    22,    23,
      24,    25,    37,   169,   170,   171,   172,    26,    54,   175,
     176,   177,    26,    27,    54,   180,   181,   182,    37,    43,
      72,    73,    74,    75,    76,    77,   185,   186,   187,   188,
      38,    78,    79,    80,    81,   191,   192,   193,   194,    28,
      29,    30,    31,    32,    33,    34,    35,    36,   196,   197,
     198,    22,    23,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,   201,   202,   203,
      22,    23,    38,    42,    47,    51,    52,    53,    79,   206,
     207,   208,   209,    25,    43,    54,    55,    56,    59,    82,
      83,   212,   213,   214,    25,    48,    54,    55,    56,   217,
     218,   219,    42,    48,    57,    58,   222,   223,   224,    48,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,   227,   228,   229,    28,    43,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,   232,   233,   234,   239,   240,
     248,   249,   147,   122,    11,   146,   151,   122,   151,   151,
     122,   151,   151,   151,   151,   151,   151,   151,   154,   154,
     122,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   122,   122,   122,   122,    11,   123,   148,   165,   151,
     122,   148,   165,   151,   121,   121,   122,   148,   165,   151,
     122,   148,   165,   151,   122,   148,   165,   151,   148,   165,
     122,   148,   165,   151,   122,   148,   165,   151,   122,   148,
     165,   151,   122,   148,   165,   151,   148,   165,   122,   148,
     165,   151,   122,   148,   165,   151,   122,   148,   165,   151,
     122,   148,   165,   121,   121,   151,   119,   125,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   122,   154,
     154,   154,   154,   154,   154,   154,   133,   134,   154,   148,
     141,   148,   169,   141,   148,   175,   136,   136,   141,   148,
     180,   141,   148,   185,   141,   148,   191,   141,   148,   141,
     148,   196,   141,   148,   201,   141,   148,   206,   141,   148,
     212,   141,   148,   141,   148,   217,   141,   148,   222,   141,
     148,   227,   141,   148,    25,    99,   100,   235,   236,   237,
     238,    25,    38,    42,    82,    99,   100,   101,   102,   103,
     104,   241,   244,   245,   246,   247,   232,   147,   147,   122,
     122,   151,   122,   151,   122,   151,   122,   151,   122,   122,
     122,   122,   122,   154,   154,   136,   148,   141,   148,   141,
     122,   122,   148,   141,   148,   141,   148,   141,   148,   141,
     148,   141,   148,   141,   148,   141,   148,   141,    55,    56,
     148,   141,   148,   141,   148,   141,   148,   141,   148,   141,
     148,   165,   148,   165,   151,   122,   121,   121,   121,   121,
     148,   165,   148,   165,   151,   122,   150,   119,   136,   136,
     136,   136,   148,     8,     9,   136,   137,   138,   139,   140,
     166,   148,   166,   148,   166,   148,   166,   148,   166,   148,
      33,    34,   166,   148,   166,   148,   166,   148,   166,   148,
     166,   148,   166,   148,   166,   148,   166,   148,   166,   148,
     166,   148,   141,   148,   141,   148,   238,   148,   148,   148,
     148,   141,   148,   141,   148,   247,   147,   147,   122,   122,
     122,   122,   124,   125,   121,   121,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   148,   141,   148,   141,   139,   140,   242,   137,   243,
     243,   243,   148,   141,   148,   141,   120,   150,   148,   122,
     136,   122,   136,   166,   148,   166,   148,   148,   148,   148,
     148,   166,   148,   166,   148,   147,   136,   151,   122,   151,
     166,   166,   122,   122,   122,   122,   166,   166,   120,   148,
     136,   136,   124,   122,   122,   151,   136,   122
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   142,   143,   143,   143,   143,   144,   145,   145,   146,
     146,   147,   147,   147,   148,   148,   149,   149,   149,   150,
     150,   151,   151,   152,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     155,   156,   156,   156,   156,   157,   158,   158,   158,   158,
     158,   159,   159,   160,   160,   161,   161,   162,   162,   163,
     163,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   165,   165,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   167,   168,   169,
     169,   169,   170,   170,   170,   171,   171,   171,   172,   172,
     173,   174,   175,   175,   175,   176,   176,   177,   177,   178,
     179,   180,   180,   180,   181,   181,   181,   181,   182,   182,
     183,   184,   185,   185,   185,   186,   186,   187,   187,   187,
     187,   187,   188,   188,   188,   188,   189,   190,   191,   191,
     191,   192,   192,   193,   193,   193,   193,   194,   194,   195,
     196,   196,   196,   197,   197,   197,   197,   197,   197,   198,
     198,   198,   198,   198,   198,   198,   198,   199,   200,   201,
     201,   201,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   203,   203,   203,   203,
     204,   205,   206,   206,   206,   207,   207,   208,   208,   208,
     208,   208,   208,   208,   208,   209,   209,   210,   211,   212,
     212,   212,   213,   213,   213,   213,   213,   213,   214,   214,
     214,   214,   215,   216,   217,   217,   217,   218,   218,   219,
     219,   219,   219,   219,   219,   219,   219,   220,   221,   222,
     222,   222,   223,   223,   223,   223,   224,   224,   225,   226,
     227,   227,   227,   228,   228,   228,   228,   228,   228,   228,
     228,   229,   229,   229,   229,   229,   229,   229,   229,   229,
     229,   230,   231,   232,   232,   232,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   234,
     235,   236,   236,   237,   237,   237,   237,   238,   238,   238,
     239,   240,   240,   240,   241,   242,   242,   243,   244,   244,
     244,   244,   245,   245,   245,   245,   245,   246,   246,   246,
     246,   246,   247,   247,   247,   248,   249,   249,   249,   249,
     250
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     1,     1,     1,     1,
       2,     0,     1,     1,     0,     1,     5,    13,    11,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     2,     3,
       6,     4,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     3,     4,     6,     8,     6,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     9,     1,     1,     1,     1,
       1,     3,     4,     6,     8,     3,     6,     4,     1,     0,
       1,     3,     1,     1,     1,     1,     1,     1,     6,     5,
       4,     1,     0,     1,     3,     1,     1,     6,     5,     4,
       1,     0,     1,     3,     1,     1,     4,     4,     6,     5,
       4,     1,     0,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     6,     5,     1,     1,     4,     1,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     6,     5,     4,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     6,
       5,     6,     5,     5,     5,     1,     1,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     5,     1,     1,
       1,     4,     0,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     5,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     1,     1,     6,     5,
       1,     1,     1,     4,     0,     1,     3,     1,     1,     6,
       5,     6,     5,     4,     1,     4,     1,     1,     4,     0,
       1,     3,     1,     1,     1,     1,     6,     5,     1,     4,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     6,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     0,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     5,     6,     5,     0,     1,     3,
       4,     1,     1,     1,     1,     1,     1,     1,     6,     6,
       6,     6,     1,     1,     1,     1,     1,     6,     5,     6,
       5,     1,     0,     1,     3,     4,     6,     5,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 562 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2369 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 563 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2375 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 564 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2381 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 565 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2387 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 569 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2393 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 573 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2399 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 574 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2405 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 578 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2411 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 579 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2417 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 583 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2423 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 584 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2429 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 585 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2435 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 589 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2441 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 590 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2447 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 593 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = -1;

			proto_packet_finish();

			realloc_packet();
		}
#line 2459 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 600 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = (yyvsp[-10].number);
			max_cpu = (yyvsp[-8].number);

			if (min_cpu > max_cpu) {
				int tmp = min_cpu;

				min_cpu = max_cpu;
				max_cpu = tmp;
			}

			proto_packet_finish();

			realloc_packet();
		}
#line 2479 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 615 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = (yyvsp[-8].number);

			proto_packet_finish();

			realloc_packet();
		}
#line 2491 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 625 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2497 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 626 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2503 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 630 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2509 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 631 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2515 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 635 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2521 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 639 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[0].number)); }
#line 2527 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 640 "trafgen_parser.y" /* yacc.c:1646  */
    { set_multi_byte((uint8_t *) (yyvsp[0].str) + 1, strlen((yyvsp[0].str)) - 2); }
#line 2533 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 641 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2539 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 642 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2545 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 643 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2551 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 644 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2557 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 645 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2563 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 646 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2569 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 647 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2575 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 648 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2581 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 649 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2587 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 650 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_header_finish(hdr); }
#line 2593 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 651 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2599 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 656 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); }
#line 2605 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 658 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 2611 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 660 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 2617 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 662 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 2623 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 664 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number); }
#line 2629 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 666 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) % (yyvsp[0].number); }
#line 2635 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 668 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) & (yyvsp[0].number); }
#line 2641 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 670 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) | (yyvsp[0].number); }
#line 2647 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 672 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) ^ (yyvsp[0].number); }
#line 2653 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 674 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) << (yyvsp[0].number); }
#line 2659 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 676 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) >> (yyvsp[0].number); }
#line 2665 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 678 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = -1 * (yyvsp[0].number); }
#line 2671 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 680 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number);}
#line 2677 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 685 "trafgen_parser.y" /* yacc.c:1646  */
    { set_fill((yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2683 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 690 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[-1].number)); }
#line 2689 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 691 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint16_t __c = cpu_to_be16((uint16_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2699 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 696 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint32_t __c = cpu_to_be32((uint32_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2709 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 701 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint64_t __c = cpu_to_be64((uint64_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2719 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 710 "trafgen_parser.y" /* yacc.c:1646  */
    { set_rnd((yyvsp[-1].number)); }
#line 2725 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 715 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_IP); }
#line 2731 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 717 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP); }
#line 2737 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 719 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP); }
#line 2743 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 721 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP6); }
#line 2749 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 723 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP6); }
#line 2755 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 728 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2761 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 730 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2767 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 735 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2773 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 737 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2779 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 742 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_rnd(); }
#line 2785 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 744 "trafgen_parser.y" /* yacc.c:1646  */
    {
			int i, max = (yyvsp[-1].number);
			for (i = 0; i < max; ++i)
				set_dynamic_rnd();
		}
#line 2795 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 753 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_INC); }
#line 2801 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 755 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_INC); }
#line 2807 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 760 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_DEC); }
#line 2813 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 762 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_DEC); }
#line 2819 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 766 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2825 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 767 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2831 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 768 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2837 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 769 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2843 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 770 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2849 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 771 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2855 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 772 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2861 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 773 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2867 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 774 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2873 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 775 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2879 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 776 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2885 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 777 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2891 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 778 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2897 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 783 "trafgen_parser.y" /* yacc.c:1646  */
    { field_index_validate(field_expr.field, (yyvsp[-2].number), 1);
		  field_expr.type |= FIELD_EXPR_OFFSET;
		  field_expr.val.func.offset = (yyvsp[-2].number);
		  field_expr.val.func.len = 1; }
#line 2906 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 788 "trafgen_parser.y" /* yacc.c:1646  */
    { field_index_validate(field_expr.field, (yyvsp[-6].number), (yyvsp[-2].number));
		  field_expr.type |= FIELD_EXPR_OFFSET;
		  field_expr.val.func.offset = (yyvsp[-6].number);
		  field_expr.val.func.len = (yyvsp[-2].number); }
#line 2915 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 795 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_NUMB;
		   field_expr.val.number = (yyvsp[0].number); }
#line 2922 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 797 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_MAC;
		memcpy(field_expr.val.mac, (yyvsp[0].mac), sizeof(field_expr.val.mac)); }
#line 2929 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 799 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_STRING;
		   field_expr.val.str = xstrdup((yyvsp[0].str) + 1);
		   field_expr.val.str[strlen((yyvsp[0].str) + 1) - 1] = '\0'; }
#line 2937 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 802 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_IP4_ADDR;
		     field_expr.val.ip4_addr = (yyvsp[0].ip4_addr); }
#line 2944 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 804 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_IP6_ADDR;
		     field_expr.val.ip6_addr = (yyvsp[0].ip6_addr); }
#line 2951 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 806 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			   field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			   field_expr.val.func.inc = 1; }
#line 2959 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 810 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2967 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 814 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number);
			  field_expr.val.func.inc = 1; }
#line 2978 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 821 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-5].number);
			  field_expr.val.func.max = (yyvsp[-3].number);
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2989 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 827 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND; }
#line 2996 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 830 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type |= FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number); }
#line 3005 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 837 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3011 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 841 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ETH); }
#line 3017 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 845 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3023 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 846 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3029 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 847 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3035 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 851 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3041 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 852 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3047 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 853 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3053 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 857 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_DST_ADDR); }
#line 3059 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 858 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_SRC_ADDR); }
#line 3065 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 859 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_TYPE); }
#line 3071 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 863 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3077 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 865 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3083 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 869 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3089 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 873 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PAUSE); }
#line 3095 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 877 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3101 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 878 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3107 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 879 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3113 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 883 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_OPCODE); }
#line 3119 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 884 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_TIME); }
#line 3125 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 889 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3131 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 891 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3137 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 895 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3143 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 899 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PFC); }
#line 3149 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 903 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3155 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 904 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3161 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 905 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3167 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 909 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_OPCODE); }
#line 3173 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 910 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_PRIO); }
#line 3179 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 912 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid prio(index) parameter");
		      panic("pfc: prio(0)..prio(7) is allowed only\n");
		  }
		  proto_field_set(PFC_PRIO_0 + (yyvsp[-1].number)); }
#line 3189 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 918 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid time(index) parameter");
		      panic("pfc: time(0)..time(7) is allowed only\n");
		  }
		  proto_field_set(PFC_TIME_0 + (yyvsp[-1].number)); }
#line 3199 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 927 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3205 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 929 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3211 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 933 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3217 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 937 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_VLAN); }
#line 3223 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 941 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3229 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 942 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3235 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 943 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3241 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 947 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3247 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 952 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TPID); }
#line 3253 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 953 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TCI); }
#line 3259 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 954 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_PCP); }
#line 3265 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 955 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_DEI); }
#line 3271 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 956 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_VID); }
#line 3277 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 961 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3283 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 963 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3289 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 965 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, VLAN_TPID, ETH_P_8021Q); }
#line 3295 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 967 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, VLAN_TPID, ETH_P_8021AD); }
#line 3301 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 971 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3307 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 975 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_MPLS); }
#line 3313 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 979 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3319 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 980 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3325 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 981 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3331 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 985 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3337 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 986 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3343 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 990 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LABEL); }
#line 3349 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 991 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TC); }
#line 3355 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 992 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LAST); }
#line 3361 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 993 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TTL); }
#line 3367 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 998 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3373 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1000 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3379 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1004 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3385 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1008 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3391 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1009 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3397 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1010 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3403 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1015 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_HTYPE); }
#line 3409 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1017 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_PTYPE); }
#line 3415 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1019 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SHA); }
#line 3421 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1021 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_THA); }
#line 3427 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1023 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SPA); }
#line 3433 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1025 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_TPA); }
#line 3439 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1030 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3445 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1032 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3451 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1034 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_OPER);
		  proto_field_expr_eval(); }
#line 3458 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1037 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_OPER);
		  proto_field_expr_eval(); }
#line 3465 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1040 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3471 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1042 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3477 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1044 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3483 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1046 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3489 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1050 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ARP); }
#line 3495 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1054 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3501 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1058 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3507 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1059 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3513 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1060 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3519 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1064 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_VER); }
#line 3525 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1065 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_IHL); }
#line 3531 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1066 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DADDR); }
#line 3537 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1067 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_SADDR); }
#line 3543 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1068 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_PROTO); }
#line 3549 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1069 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TTL); }
#line 3555 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1070 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DSCP); }
#line 3561 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1071 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ECN); }
#line 3567 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1072 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TOS); }
#line 3573 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1073 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_LEN); }
#line 3579 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1074 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ID); }
#line 3585 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1075 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FLAGS); }
#line 3591 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1076 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FRAG_OFFS); }
#line 3597 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1077 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_CSUM); }
#line 3603 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1082 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3609 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1084 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3615 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1085 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, IP4_DF, 1); }
#line 3621 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1086 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, IP4_MF, 1); }
#line 3627 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1090 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP4); }
#line 3633 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1094 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3639 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1098 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3645 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1099 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3651 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1100 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3657 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1104 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3663 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1105 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3669 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1109 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_VER); }
#line 3675 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1110 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_CLASS); }
#line 3681 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1111 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_FLOW_LBL); }
#line 3687 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1112 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_LEN); }
#line 3693 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1113 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_NEXT_HDR); }
#line 3699 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1114 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_HOP_LIMIT); }
#line 3705 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1115 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_SADDR); }
#line 3711 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1116 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_DADDR) ; }
#line 3717 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1121 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3723 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1123 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3729 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1127 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP6); }
#line 3735 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1131 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3741 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1135 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3747 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1136 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3753 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1137 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3759 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1141 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_TYPE); }
#line 3765 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1142 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_CODE); }
#line 3771 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1143 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_ID); }
#line 3777 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1144 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_SEQ); }
#line 3783 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1145 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_MTU); }
#line 3789 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1146 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_REDIR_ADDR); }
#line 3795 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1151 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3801 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1153 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3807 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1155 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHO);
		  proto_hdr_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3814 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1158 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHOREPLY);
		  proto_hdr_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3821 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1163 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP4); }
#line 3827 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1167 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3833 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1171 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3839 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1172 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3845 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1173 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3851 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1177 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CODE); }
#line 3857 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1178 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CSUM); }
#line 3863 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1183 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3869 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1185 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3875 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1187 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_TYPE);
		  proto_field_expr_eval(); }
#line 3882 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1190 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_TYPE);
		  proto_field_expr_eval(); }
#line 3889 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1193 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3895 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1195 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3901 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1197 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3907 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1199 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3913 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1202 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP6); }
#line 3919 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1206 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3925 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1210 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3931 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1211 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3937 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1212 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3943 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1216 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_SPORT); }
#line 3949 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1217 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_DPORT); }
#line 3955 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1218 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_LEN); }
#line 3961 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1219 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_CSUM); }
#line 3967 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1224 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3973 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1226 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3979 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1230 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_UDP); }
#line 3985 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1234 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3991 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1238 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3997 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1239 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4003 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1240 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4009 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1244 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SPORT); }
#line 4015 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1245 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DPORT); }
#line 4021 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1246 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SEQ); }
#line 4027 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1247 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_ACK_SEQ); }
#line 4033 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1248 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DOFF); }
#line 4039 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1249 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_WINDOW); }
#line 4045 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1250 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_CSUM); }
#line 4051 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1251 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_URG_PTR); }
#line 4057 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1256 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4063 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1258 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4069 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1259 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_CWR, 1); }
#line 4075 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1260 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_ECE, 1); }
#line 4081 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1261 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_URG, 1); }
#line 4087 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1262 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_ACK, 1); }
#line 4093 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1263 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_PSH, 1); }
#line 4099 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1264 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_RST, 1); }
#line 4105 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1265 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_SYN, 1); }
#line 4111 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1266 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, TCP_FIN, 1); }
#line 4117 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1270 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_TCP); }
#line 4123 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1274 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4129 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1278 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4135 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1279 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4141 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1280 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4147 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1284 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_ID); }
#line 4153 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1285 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_QR); }
#line 4159 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1286 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_OPCODE); }
#line 4165 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1287 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_AA); }
#line 4171 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1288 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_TC); }
#line 4177 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1289 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RD); }
#line 4183 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1290 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RA); }
#line 4189 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1291 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_ZERO); }
#line 4195 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1292 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RCODE); }
#line 4201 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1293 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_QD_COUNT); }
#line 4207 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1294 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_AN_COUNT); }
#line 4213 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1295 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_NS_COUNT); }
#line 4219 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1296 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_AR_COUNT); }
#line 4225 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1300 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_push_sub_hdr(DNS_QUERY_HDR); }
#line 4231 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1304 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_QUERY_NAME); }
#line 4237 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1308 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_QUERY_TYPE); }
#line 4243 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1309 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_QUERY_CLASS); }
#line 4249 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1314 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4255 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1316 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4261 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1318 "trafgen_parser.y" /* yacc.c:1646  */
    { if (field_expr.type & FIELD_EXPR_STRING)
			field_expr.type = FIELD_EXPR_FQDN;
		  proto_field_expr_eval(); }
#line 4269 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1322 "trafgen_parser.y" /* yacc.c:1646  */
    { if (field_expr.type & FIELD_EXPR_STRING)
			field_expr.type = FIELD_EXPR_FQDN;
		  proto_field_expr_eval(); }
#line 4277 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1328 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4283 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1329 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4289 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1330 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4295 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1334 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4301 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1338 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_push_sub_hdr(DNS_ANSWER_HDR); }
#line 4307 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1339 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_push_sub_hdr(DNS_AUTH_HDR); }
#line 4313 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1340 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_push_sub_hdr(DNS_ADD_HDR); }
#line 4319 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1344 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_NAME); }
#line 4325 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1349 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_u32(hdr, DNS_RRECORD_DATA, (yyvsp[0].ip4_addr).s_addr);
		  proto_hdr_field_set_be16(hdr, DNS_RRECORD_TYPE, 1); }
#line 4332 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1352 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_bytes(hdr, DNS_RRECORD_DATA, (uint8_t *)&(yyvsp[0].ip6_addr).s6_addr, 16);
		  proto_hdr_field_set_be16(hdr, DNS_RRECORD_TYPE, 28); }
#line 4339 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1358 "trafgen_parser.y" /* yacc.c:1646  */
    { char *str = xstrdup((yyvsp[0].str) + 1);
		  char *fqdn;
		  str[strlen((yyvsp[0].str) + 1) - 1] = '\0';
		  fqdn = str2fqdn(str);
		  proto_hdr_field_set_bytes(hdr, DNS_RRECORD_DATA, (uint8_t *) fqdn, strlen(fqdn) + 1);
		  xfree(str);
		  xfree(fqdn); }
#line 4351 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1369 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4357 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1371 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, DNS_RRECORD_TYPE, 2); }
#line 4363 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1373 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, DNS_RRECORD_TYPE, 5); }
#line 4369 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1375 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_hdr_field_set_be16(hdr, DNS_RRECORD_TYPE, 12); }
#line 4375 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1379 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_TYPE); }
#line 4381 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1380 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_CLASS); }
#line 4387 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1381 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_TTL); }
#line 4393 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1382 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_LEN); }
#line 4399 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1383 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(DNS_RRECORD_DATA); }
#line 4405 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1388 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4411 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1390 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4417 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1392 "trafgen_parser.y" /* yacc.c:1646  */
    { if (field_expr.type & FIELD_EXPR_STRING)
			field_expr.type = FIELD_EXPR_FQDN;
		  proto_field_expr_eval(); }
#line 4425 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1396 "trafgen_parser.y" /* yacc.c:1646  */
    { if (field_expr.type & FIELD_EXPR_STRING)
			field_expr.type = FIELD_EXPR_FQDN;
		  proto_field_expr_eval(); }
#line 4433 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1400 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4439 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1404 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4445 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1405 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4451 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1406 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4457 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1410 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 4463 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1415 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4469 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1417 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 4475 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1418 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_pop_sub_hdr(); }
#line 4481 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1419 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_pop_sub_hdr(); }
#line 4487 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1423 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_DNS); }
#line 4493 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;


#line 4497 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1425 "trafgen_parser.y" /* yacc.c:1906  */


static void finalize_packet(void)
{
	/* XXX hack ... we allocated one packet pointer too much */
	plen--;
	dlen--;
}

static void dump_conf(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		printf("[%zu] pkt\n", i);
		printf(" len %zu cnts %zu rnds %zu\n",
		       packets[i].len,
		       packet_dyn[i].clen,
		       packet_dyn[i].rlen);

		printf(" payload ");
		for (j = 0; j < packets[i].len; ++j)
			printf("%02x ", packets[i].payload[j]);
		printf("\n");

		for (j = 0; j < packet_dyn[i].clen; ++j)
			printf(" cnt%zu [%u,%u], inc %u, off %jd type %s\n", j,
			       packet_dyn[i].cnt[j].min,
			       packet_dyn[i].cnt[j].max,
			       packet_dyn[i].cnt[j].inc,
			       (intmax_t)packet_dyn[i].cnt[j].off,
			       packet_dyn[i].cnt[j].type == TYPE_INC ?
			       "inc" : "dec");

		for (j = 0; j < packet_dyn[i].rlen; ++j)
			printf(" rnd%zu off %jd\n", j,
			       (intmax_t)packet_dyn[i].rnd[j].off);
	}
}

void cleanup_packets(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		struct packet *pkt = &packets[i];

		if (pkt->len > 0)
			xfree(pkt->payload);

		for (j = 0; j < pkt->headers_count; j++) {
			struct proto_hdr *hdr = pkt->headers[j];
			int k;

			for (k = 0; k < hdr->sub_headers_count; k++)
				xfree(hdr->sub_headers[k]);

			if (hdr->sub_headers)
				xfree(hdr->sub_headers);

			if (hdr->fields)
				xfree(hdr->fields);

			xfree(hdr);
		}
	}

	free(packets);

	for (i = 0; i < dlen; ++i) {
		free(packet_dyn[i].cnt);
		free(packet_dyn[i].rnd);

		for (j = 0; j < packet_dyn[j].flen; j++)
			xfree(packet_dyn[i].fields[j]);

		free(packet_dyn[i].fields);
	}

	free(packet_dyn);
}

void compile_packets(char *file, bool verbose, unsigned int cpu,
		     bool invoke_cpp, char *const cpp_argv[])
{
	char tmp_file[128];
	int ret = -1;

	if (strncmp("-", file, strlen("-")) && access(file, R_OK)) {
		fprintf(stderr, "Cannot access %s: %s!\n", file, strerror(errno));
		die();
	}

	memset(tmp_file, 0, sizeof(tmp_file));
	our_cpu = cpu;

	if (invoke_cpp) {
		if (cpp_exec(file, tmp_file, sizeof(tmp_file), cpp_argv)) {
			fprintf(stderr, "Failed to invoke C preprocessor!\n");
			goto err;
		}
		file = tmp_file;
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin) {
		fprintf(stderr, "Cannot open %s: %s!\n", file, strerror(errno));
		goto err;
	}

	realloc_packet();
	if (yyparse() != 0)
		goto err;
	finalize_packet();

	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	if (yyin && yyin != stdin)
		fclose(yyin);

	if (invoke_cpp)
		unlink(tmp_file);
	if (ret)
		die();
}

void compile_packets_str(char *str, bool verbose, unsigned int cpu)
{
	int ret = 1;

	our_cpu = cpu;
	realloc_packet();

	yy_scan_string(str);
	if (yyparse() != 0)
		goto err;

	finalize_packet();
	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	yylex_destroy();

	if (ret)
		die();
}

void yyerror(const char *err)
{
	fprintf(stderr, "Syntax error at line %d, char '%s': %s\n", yylineno, yytext, err);
}
